﻿namespace DTOs
{
    /// <summary>
    /// define a DTO of an answer for a Question with Mutiple Choice
    /// properties :
    ///     Id : identifier in the database
    ///     Content : content of the answer
    /// </summary>
    public class AnswerDto
    {
        public int Id { get; set; }
        public string Content { get; set; } = null!;

        /// <summary>
        /// constructor of an answer
        /// </summary>
        /// <param name="content">the content of an answer</param>
        /// <param name="id">the id of an answer</param>
        public AnswerDto(string content, int id = -1)
        {
            Content = content;
            Id = id;
        }
    }
}
